---
title: WakeLockSentinel
slug: Web/API/WakeLockSentinel
tags:
  - API
  - Interface
  - Reference
  - Screen Wake Lock API
  - Wake Lock
  - screen
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("Screen Wake Lock API")}}</div>

<p class="summary">The <strong><code>WakeLockSentinel</code></strong> interface of the {{domxref('Screen Wake Lock API')}} provides a handle to the underlying platform wake lock and can be manually released and reacquired. An {{jsxref('Object')}} representing the wake lock is returned via the {{domxref('WakeLock.request()','navigator.wakelock.request()')}} method.</p>

<p>An acquired <code>WakeLockSentinel</code> can be released manually via the {{domxref('WakeLockSentinel.release','release()')}} method, or automatically via the platform wake lock. This can happen if the document becomes inactive or looses visibility, if the device is low on power or the user turns on a power save mode. Releasing all <code>WakeLockSentinel</code> instances of a given wake lock type will cause the underlying platform wake lock to be released.</p>

<h2 id="Properties">Properties</h2>

<p><em>This interface provides the following properties.</em></p>

<dl>
	<dt>{{domxref("WakeLockSentinel.released", "released")}} {{ReadOnlyInline}}</dt>
	<dd>Returns a boolean indicating whether the <code>WakeLockSentinel</code> has been released.</dd>
	<dt>{{domxref("WakeLockSentinel.type", "type")}} {{ReadOnlyInline}}</dt>
	<dd>Returns a {{jsxref("String")}} representation of the currently acquired <code>WakeLockSentinel</code> type.<br>
	Return values are:
	<ul>
		<li><code>'screen'</code>: A screen wake lock. Prevents devices from dimming or locking the screen.</li>
	</ul>
	</dd>
</dl>

<h2 id="Event_handlers">Event handlers</h2>

<dl>
	<dt>{{domxref("WakeLockSentinel.onrelease", "onrelease")}}</dt>
	<dd>Fired when the {{domxref('WakeLockSentinel.release','release()')}} method is called or the wake lock is released by the user agent.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
	<dt>{{domxref('WakeLockSentinel.release()', 'release()')}}</dt>
	<dd>Releases the <code>WakeLockSentinel</code>, returning a {{jsxref("Promise")}} that is resolved once the sentinel has been successfully released.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In this example we create an asynchronous function which requests a <code>WakeLockSentinel</code>. Once acquired we listen for the <code>onrelease</code> event which can be used to give appropriate UI feedback. The sentinel can be acquired or released via appropriate interactions.</p>

<pre class="brush: js notranslate">// create a reference for the wake lock
let wakeLock = null;

// create an async function to request a wake lock
const requestWakeLock = async () =&gt; {
  try {
    wakeLock = await navigator.wakeLock.request('screen');

    // listen for our release event
    wakeLock.addEventListener('release', () =&gt; {
      // if wake lock is released alter the UI accordingly
    });

  } catch (err) {
    // if wake lock request fails - usually system related, such as battery

  }
}

wakeLockOnButton.addEventListener('click', () =&gt; {
  requestWakeLock();
})

wakeLockOffButton.addEventListener('click', () =&gt; {
  if (wakeLock !== null) {
    wakeLock.release()
      .then(() =&gt; {
        wakeLock = null;
      })
  }
})
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Screen Wake Lock','#the-wakelocksentinel-interface','WakeLockSentinel')}}</td>
			<td>{{Spec2('Screen Wake Lock')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.WakeLockSentinel")}}</p>
